#include "GeneratorFactory.h"

#include <iostream>
#include <stdexcept>

GeneratorImplementation* GeneratorImplementation::m_Instance = 0;

GeneratorImplementation* GeneratorImplementation::Instance()
{
    if (!m_Instance)   // Only allow one instance of class to be generated.
        m_Instance = new GeneratorImplementation;
    return m_Instance;
}

void GeneratorImplementation::Print()
{
    if (this->implementation != NULL)
        this->implementation->Print();
    else
        throw runtime_error("Target language generator is not set.");
}

/** @brief GenerateCode
  *
  * @todo: document this function
  */
void GeneratorImplementation::GenerateCode(string dir, string programName)
{
    if (this->implementation != NULL)
        this->implementation->GenerateCode(dir, programName);
    else
        throw runtime_error("Target language generator is not set.");
}

/** @brief CreateKeysMessage
  *
  * @todo: document this function
  */
pnClass* GeneratorImplementation::CreateClass(ClassHead *head, pnNet *_objectNet, pnClassContent *content)
{
    if (this->implementation != NULL)
        return this->implementation->CreateClass(head, _objectNet, content);
    else
        throw runtime_error("Target language generator is not set.");
}

void GeneratorImplementation::SetStartClass(string className)
{
    if (this->implementation != NULL)
        return this->implementation->SetStartClass(className);
    else
        throw runtime_error("Target language generator is not set.");
}

void GeneratorImplementation::AddClass(ClassHead *head, pnNet *_objectNet, pnClassContent *content)
{
    if (this->implementation != NULL)
        return this->implementation->AddClass(head, _objectNet, content);
    else
        throw runtime_error("Target language generator is not set.");
}


/** @brief CreateKeysMessage
  *
  * @todo: document this function
  */
pnMessageKeys* GeneratorImplementation::CreateKeysMessage()
{
    if (this->implementation != NULL)
        return this->implementation->CreateKeysMessage();
    else
        throw runtime_error("Target language generator is not set.");
}

/** @brief CreateBinaryMessage
  *
  * @todo: document this function
  */
pnMessageBinary* GeneratorImplementation::CreateBinaryMessage(string msg, pnOperand* op, pnMessageUnary *opChain)
{
    if (this->implementation != NULL)
        return this->implementation->CreateBinaryMessage(msg, op, opChain);
    else
        throw runtime_error("Target language generator is not set.");
}

/** @brief CreateUnaryMessage
  *
  * @todo: document this function
  */
pnMessageUnary* GeneratorImplementation::CreateUnaryMessage(string msg, pnMessageUnary *nextMsg)
{
    if (this->implementation != NULL)
        return this->implementation->CreateUnaryMessage(msg, nextMsg);
    else
        throw runtime_error("Target language generator is not set.");
}

/** @brief CreateMultisetItemSymbol
  *
  * @todo: document this function
  */
SymbolLiteral* GeneratorImplementation::CreateMultisetItemSymbol(string value)
{
    if (this->implementation != NULL)
        return this->implementation->CreateMultisetItemSymbol(value);
    else
        throw runtime_error("Target language generator is not set.");
}

/** @brief CreateMultisetItemString
  *
  * @todo: document this function
  */
StringLiteral* GeneratorImplementation::CreateMultisetItemString(string value)
{
    if (this->implementation != NULL)
        return this->implementation->CreateMultisetItemString(value);
    else
        throw runtime_error("Target language generator is not set.");
}

/** @brief CreateMultisetItemChar
  *
  * @todo: document this function
  */
CharLiteral* GeneratorImplementation::CreateMultisetItemChar(char value)
{
    if (this->implementation != NULL)
        return this->implementation->CreateMultisetItemChar(value);
    else
        throw runtime_error("Target language generator is not set.");
}

/** @brief CreateMultisetItemInt
  *
  * @todo: document this function
  */
IntegerLiteral* GeneratorImplementation::CreateMultisetItemInt(int value)
{
    if (this->implementation != NULL)
        return this->implementation->CreateMultisetItemInt(value);
    else
        throw runtime_error("Target language generator is not set.");
}

/** @brief CreateMultisetItemList
  *
  * @todo: document this function
  */
pnMultisetItemList* GeneratorImplementation::CreateMultisetItemList()
{
    if (this->implementation != NULL)
        return this->implementation->CreateMultisetItemList();
    else
        throw runtime_error("Target language generator is not set.");
}

/** @brief CreateMultisetItemLiteral
  *
  * @todo: document this function
  */
pnSetItem* GeneratorImplementation::CreateMultisetItemLiteral(Literal* literal)
{
    if (this->implementation != NULL)
        return this->implementation->CreateMultisetItemLiteral(literal);
    else
        throw runtime_error("Target language generator is not set.");
}

/** @brief CreateMultisetItemVar
  *
  * @todo: document this function
  */
pnSetItem* GeneratorImplementation::CreateMultisetItemVar(string varName)
{
    if (this->implementation != NULL)
        return this->implementation->CreateMultisetItemVar(varName);
    else
        throw runtime_error("Target language generator is not set.");
}

/** @brief CreateOperandToken
  *
  * @todo: document this function
  */
pnOperandLiteral* GeneratorImplementation::CreateOperandToken(Literal *literal)
{
    if (this->implementation != NULL)
        return this->implementation->CreateOperandToken(literal);
    else
        throw runtime_error("Target language generator is not set.");
}

/** @brief CreateOperandVar
  *
  * @todo: document this function
  */
pnOperandVar* GeneratorImplementation::CreateOperandVar(string varName)
{
    if (this->implementation != NULL)
        return this->implementation->CreateOperandVar(varName);
    else
        throw runtime_error("Target language generator is not set.");
}

/** @brief CreateOperandVar
  *
  * @todo: document this function
  */
bool GeneratorImplementation::DoSemantics()
{
    if (this->implementation != NULL)
        return this->implementation->DoSemantics();
    else
        throw runtime_error("Target language generator is not set.");
}

