#ifndef BINDINGS_H
#define BINDINGS_H

#include <string>
#include "PN_Condition.h"


using namespace std;

class PN_TransitionBinding
{
    public:
        list<PN_Binding> bindings;
        void AddBinding(string var, Token* trg) {this->bindings.push_back(PN_Binding(var, trg));}
        bool Merge(PN_TransitionBinding* other);
        void Print();
};


/** \brief Represent state of Binding
 */
class BindingState
{
private:
    PN_Place placeCopy;
public:
    BindingState(PN_Place *place, PN_Multiset *set) : placeCopy(*place), multiSetToBind(set->items) {}
    PN_Place *GetPlaceCopy() {return &placeCopy;}
    list<PN_Binding> foundBindings;
    list<PN_MultiItem*> multiSetToBind;
    void Print();
};

class BindingFinder
{
    public:
        BindingFinder(PN_Condition *cond);
        list<PN_TransitionBinding*> *GetBindingsNew();
        PN_TransitionBinding* GetNextBinding();
        void SetPartialBinding(PN_TransitionBinding* b);
    private:
        PN_Condition *cond;
        list<BindingState *> states;
        PN_TransitionBinding* partialBinding;
};

class PN_ListNotBindable : PN_Exception
{

};

void PrintBindings(list<PN_Binding>& binds);
void DisposeBindings(list<PN_Binding>& binds);

#endif // BINDINGS_H
