#include "PN_Condition.h"

#include <algorithm>
#include <sstream>

PN_Condition::PN_Condition(PN_Place *p, PN_Multiset *s, string _name)
{
    this->targetPlace = p;
    this->set = s;
    this->name = _name;
}

PN_Condition::~PN_Condition()
{
    // place is freed by net
    delete this->set;
}

void PN_Condition::DoAsPrecond(list<PN_Binding> bindings)
{
    list<PN_MultiItem*>::iterator it_var, it_end;
    it_var = set->items.begin();
    it_end = set->items.end();

    list<Token*> tokens;
    list<PN_MultiItemVariable*> inputVars;

    for(; it_var != it_end; it_var++)
    {

            list <Token*> list2 = (*it_var)->Tokenize(bindings);
            tokens.insert(tokens.end(), list2.begin(), list2.end());

    }
/*
    cout << "preconds (" << this->targetPlace->GetName() << "): ";
    list<Token *>::iterator it_varp, it_endp;
    it_varp = tokens.begin();
    it_endp = tokens.end();

    for(; it_varp != it_endp; it_varp++)
    {
        (*it_varp)->Print();
        cout << ", ";
    }
    cout << endl;
*/
    tokens.sort(compare_tokens_lt);
    targetPlace->PopTokens(&tokens);
    DisposeRefList(tokens);
}

void PN_Condition::DoAsPostcond(list<PN_Binding> bindings)
{
    list<PN_MultiItem*>::iterator it_var, it_end;
    it_var = set->items.begin();
    it_end = set->items.end();

    list<Token*> tokens;

    for(; it_var != it_end; it_var++)
    {
        try
        {
            list <Token*> list2 = (*it_var)->Tokenize(bindings);
            tokens.insert(tokens.end(), list2.begin(), list2.end());
        }
        catch (PN_Error_Exception *ex)
        {
            cerr << "Postcond failed!" << endl;
            throw ex;
        }
    }
/*
    cout << "postcond (" << this->targetPlace->GetName() << "): ";
    list<Token *>::iterator it_varp, it_endp;
    it_varp = tokens.begin();
    it_endp = tokens.end();

    for(; it_varp != it_endp; it_varp++)
    {
        (*it_varp)->Print();
        cout << ", ";
    }
    cout << endl;
*/
    targetPlace->PushTokens(&tokens);

}
