#include "PN_Multiset.h"

PN_Multiset::PN_Multiset()
{
    //ctor
}

PN_Multiset::~PN_Multiset()
{
    DisposeRefList(this->items);
}

/** @brief AddItem
  *
  * @todo: document this function
  */
void PN_Multiset::AddItem(PN_MultiItem *item)
{
    this->items.push_back(item);
}

/** @brief CreateTokenPrototype
  *
  * @todo: document this function
  */
Token* PN_MultiItemVariable::CreateTokenPrototype(list<PN_Binding>& binding)
{
    Token* result = NULL;
    list<PN_Binding>::iterator it_var, it_end ;
    it_var = binding.begin();
    it_end = binding.end();

    for (; it_var != it_end; it_var++)
    {
        if(it_var->varName == this->varname )
        {
            result = it_var->target->Copy();
        }
    }
    if (result == NULL)
    {
        ostringstream text;
        text << "variable " << this->varname << " coudn't be bind.\n";
        text << "Provided bindings: ";

        list<PN_Binding>::iterator it_var2 = binding.begin();
        list<PN_Binding>::iterator it_end2 = binding.end();

        while (it_var2!=it_end2)
        {
            text << it_var2->varName << " = " << it_var2->target->AsText();
            text << ", ";
            ++it_var2;
        }
        text << ".\n";

        throw new PN_Error_Exception(text.str());
    }
    return result;
}

/** @brief CreateTokenPrototype
  *
  * @todo: document this function
  */
Token* PN_MultiItemSymbol::CreateTokenPrototype()
{
    return new SymbolToken(this->value);
}

/** @brief CreateTokenPrototype
  *
  * @todo: document this function
  */
Token* PN_MultiItemChar::CreateTokenPrototype()
{
   return new CharToken(this->value);
}

/** @brief CreateTokenPrototype
  *
  * @todo: document this function
  */
Token* PN_MultiItemString::CreateTokenPrototype()
{
    return new StringToken(this->value);
}

/** @brief CreateTokenPrototype
  *
  * @todo: document this function
  */
Token* PN_MultiItemInt::CreateTokenPrototype()
{
   return new IntToken(this->value);
}

/** @brief CreateTokenPrototype
  *
  * @todo: document this function
  */
Token* PN_MultiItemList::CreateTokenPrototype(list<PN_Binding>& binding)
{
    ListToken *tokenL = new ListToken();

    list<PN_MultiItem*>::iterator it_var, it_end;
    it_var = this->listCol.begin();
    it_end = this->listCol.end();

    for (; it_var != it_end; it_var++)
    {
        list<Token*> itemList = (*it_var)->Tokenize(binding);
        tokenL->collection.insert(tokenL->collection.end(), itemList.begin(), itemList.end());
    }
    return tokenL;
}

void PN_MultiItemList::Print()
{
    cout << quantity << "`(";
    list<PN_MultiItem*>::iterator it_var, it_end;
    it_var = this->listCol.begin();
    it_end = this->listCol.end();

    for (; it_var != it_end; it_var++)
    {
        (*it_var)->Print();
        cout << ", ";
    }
    cout << ")";
}





