#include "PN_Place.h"

#include <typeinfo>

void AllTokensIterator::Increment(bool do_not_incrementate)
{
    bool incremented = do_not_incrementate;
    switch (act_type)
    {
    case integers:
        if (!incremented)
        {
            act_int++;
            incremented = true;
        }
        if (act_int == parent->integersCol.end())
            act_type = static_cast<TokenType>( ((int)act_type) + 1);
        else break;
    case chars:
        if (!incremented)
        {
            act_char++;
            incremented = true;
        }
        if (act_char == parent->charCol.end())
            act_type = static_cast<TokenType>( ((int)act_type) + 1);
        else break;
    case strings:
        if (!incremented)
        {
            act_string++;
            incremented = true;
        }
        if (act_string == parent->stringCol.end())
            act_type = static_cast<TokenType>( ((int)act_type) + 1);
        else break;
    case symbols:
        if (!incremented)
        {
            act_symbol++;
            incremented = true;
        }
        if (act_symbol == parent->symbolCol.end())
            act_type = static_cast<TokenType>( ((int)act_type) + 1);
        else break;
    case refs:
        if (!incremented)
        {
            act_ref++;
            incremented = true;
        }
        if (act_ref == parent->refCol.end())
            act_type = static_cast<TokenType>( ((int)act_type) + 1);
        else break;
    case lists:
        if (!incremented)
        {
            act_list++;
            incremented = true;
        }
        if (act_list == parent->listCol.end())
            act_type = static_cast<TokenType>( ((int)act_type) + 1);
        else break;
    case end:
        break;
    }
}

Token* AllTokensIterator::operator*() const
{
    switch (act_type)
    {
    case integers:
        return *act_int;
    case chars:
        return *act_char;
    case strings:
        return *act_string;
    case symbols:
        return *act_symbol;
    case refs:
        return *act_ref;
    case lists:
        return *act_list;
    case end:
        return NULL;
    }
    return NULL; // in case switch fails
}

void AllTokensIterator::EraseActual()
{
    switch (act_type)
    {
    case integers:
//        if (destroyTokens)
//        {
//            delete *act_int;
//        }
        act_int = parent->integersCol.erase(act_int);
        break;
    case chars:
//        if (destroyTokens)
//        {
//            delete *act_char;
//        }
        act_char = parent->charCol.erase(act_char);
        break;
    case strings:
//        if (destroyTokens)
//        {
//            delete *act_string;
//        }
        act_string = parent->stringCol.erase(act_string);
        break;
    case symbols:
//        if (destroyTokens)
//        {
//            delete *act_symbol;
//        }
        act_symbol = parent->symbolCol.erase(act_symbol);
        break;
    case refs:
//        if (destroyTokens)
//        {
//            delete *act_ref;
//        }
        act_ref = parent->refCol.erase(act_ref);
        break;
    case lists:
//        if (destroyTokens)
//        {
//            delete *act_list;
//        }
        act_list = parent->listCol.erase(act_list);
        break;
    case end:
        break;
    }
    this->Increment(true);
}

AllTokensIterator::AllTokensIterator(PN_Place *p)
{
    parent = p;
    act_type = integers;
    act_int = p->integersCol.begin();
    act_char = p->charCol.begin();
    act_string = p->stringCol.begin();
    act_symbol = p->symbolCol.begin();
    act_ref = p->refCol.begin();
    act_list = p->listCol.begin();
    this->Increment(true);
}

PN_Place::~PN_Place()
{
    //dtor
}

AllTokensIterator *PN_Place::GetIter()
{
    return new AllTokensIterator(this);
}

/** @brief PN_Place
  *
  * @todo: document this function
  */
PN_Place::PN_Place(PN_Multiset *s, string _name) : name(_name)
{
    list<PN_MultiItem*>::iterator it_var, it_end;
    it_var = s->items.begin();
    it_end = s->items.end();

// TODO (martin#1#): Execute init action here
    list<PN_Binding> nameSpace;

    list<Token*> tokens;

    for(; it_var != it_end; it_var++)
    {
        list<Token*> itemTokens = (*it_var)->Tokenize(nameSpace);
        tokens.insert(tokens.end(), itemTokens.begin(), itemTokens.end());
    }
    PushTokens(&tokens);
}

/** @brief PushTokens
  *
  * @todo: document this function
  */
void PN_Place::PushTokens(list<Token*> *tokens)
{
    list<Token*>::iterator it_var, it_end;
    it_var = tokens->begin();
    it_end = tokens->end();

    for(; it_var != it_end; it_var++)
    {
        switch ((*it_var)->GetType())
        {
            case integer_token:
                this->integersCol.push_back((IntToken*)*it_var);
                break;
            case bool_token:

                break;
            case character_token:
                this->charCol.push_back((CharToken*)*it_var);
                break;
            case string_token:
                this->stringCol.push_back((StringToken*)*it_var);
                break;
            case symbol_token:
                this->symbolCol.push_back((SymbolToken*)*it_var);
                break;
            case reference_token:
                this->refCol.push_back(*it_var);
                break;
            case list_token:
                this->listCol.push_back((ListToken*)*it_var);
                break;
            default:
                cerr << "Error: unsuccessful typecast on storing token to place (" << typeid(**it_var).name() << ")\n";
                break;
        }
    }

    this->integersCol.sort(compare_tokens_lt);
    this->charCol.sort(compare_tokens_lt);
    this->stringCol.sort(compare_tokens_lt);
    this->symbolCol.sort(compare_tokens_lt);
    this->listCol.sort(compare_tokens_lt);
    this->refCol.sort(compare_tokens_lt);
}

/** @brief PopTokens
  *
  * @todo: document this function
  */
void PN_Place::PopTokens(list<Token*> *tokens)
{
    tokens->sort(compare_tokens_lt);
    list<Token*>::iterator it_var, it_end;
    it_var = tokens->begin();
    it_end = tokens->end();

    AllTokensIterator *it_var2 = this->GetIter();

    for(; it_var != it_end; it_var++)
    {
//        cout << "deleting " ;
//        (*it_var)->Print();
//        cout << "from place ";
//        this->PrintContent();
//        cout << endl;

        while (!(it_var2->IsAtEnd()))
        {
            if(compare_tokens_cmp(*it_var, **it_var2) == 0)
            {
                break;
            }
            it_var2->Increment();
        }

        if(it_var2->IsAtEnd())
        {
            throw PN_PlaceNotContainException("Exception: couldn't pop all desired tokens from place");
        }

        it_var2->EraseActual();
    }
    delete it_var2;
}

int PN_Place::PopTokenGreedy(Token *token)
{
    AllTokensIterator *it = this->GetIter();
    int result = 0;

    while(!it->IsAtEnd())
    {
        if(compare_tokens_cmp(**it, token) == 0)
        {
            result++;
            it->EraseActual();
        }
        else
        {
            if (result > 0)
            {
                break;
            }
            it->Increment();
        }
    }
    delete it;
    return result;
}

void PN_Place::Clear()
{
    list<IntToken*>::iterator it_var, it_end;
    it_var = this->integersCol.begin();
    it_end = this->integersCol.end();

    for(; it_var != it_end; it_var++)
    {
        delete *it_var;
    }
    list<CharToken*>::iterator it_varc, it_endc;
    it_varc = this->charCol.begin();
    it_endc = this->charCol.end();

    for(; it_varc != it_endc; it_varc++)
    {
        delete *it_varc;
    }
    list<StringToken*>::iterator it_vars, it_ends;
    it_vars = this->stringCol.begin();
    it_ends = this->stringCol.end();

    for(; it_vars != it_ends; it_vars++)
    {
        delete *it_vars;
    }
    list<SymbolToken*>::iterator it_varss, it_endss;
    it_varss = this->symbolCol.begin();
    it_endss = this->symbolCol.end();

    for(; it_varss != it_endss; it_varss++)
    {
        delete *it_varss;
    }
    list<Token*>::iterator it_varr, it_endr;
    it_varr = this->refCol.begin();
    it_endr = this->refCol.end();

    for(; it_varr != it_endr; it_varr++)
    {
        delete *it_varr;
    }
    list<ListToken*>::iterator it_varl, it_endl;
    it_varl = this->listCol.begin();
    it_endl = this->listCol.end();

    for(; it_varl != it_endl; it_varl++)
    {
        delete *it_varl;
    }
}

/** @brief PrintContent
  *
  * @todo: document this function
  */
void PN_Place::PrintContent()
{
    cout << "place \"" << this->name <<"\" content:\n";
    list<IntToken*>::iterator it_var, it_end;
    it_var = this->integersCol.begin();
    it_end = this->integersCol.end();

    for(; it_var != it_end; it_var++)
    {
        cout << (*it_var)->value << ", ";
    }
    list<CharToken*>::iterator it_varc, it_endc;
    it_varc = this->charCol.begin();
    it_endc = this->charCol.end();

    for(; it_varc != it_endc; it_varc++)
    {
        cout << "$" <<(*it_varc)->value << ", ";
    }
    list<StringToken*>::iterator it_vars, it_ends;
    it_vars = this->stringCol.begin();
    it_ends = this->stringCol.end();

    for(; it_vars != it_ends; it_vars++)
    {
        cout << "'"<< (*it_vars)->value << "', ";
    }
    list<SymbolToken*>::iterator it_varss, it_endss;
    it_varss = this->symbolCol.begin();
    it_endss = this->symbolCol.end();

    for(; it_varss != it_endss; it_varss++)
    {
        cout << "#"<<(*it_varss)->value << ", ";
    }
    list<Token*>::iterator it_varr, it_endr;
    it_varr = this->refCol.begin();
    it_endr = this->refCol.end();

    for(; it_varr != it_endr; it_varr++)
    {
        (*it_varr)->Print(); cout << ", ";
    }
    list<ListToken*>::iterator it_varl, it_endl;
    it_varl = this->listCol.begin();
    it_endl = this->listCol.end();

    for(; it_varl != it_endl; it_varl++)
    {
        cout << (*it_varl)->AsText() << ", ";
    }
    cout << endl;

}



