#include "PNsimulation.h"

#include <list>
#include <vector>
#include <ctime>
#include <cstdlib>

PNsimulation* PNsimulation::m_Instance = 0;

PNsimulation* PNsimulation::Instance()
{
    if (!m_Instance)   // Only allow one instance of class to be generated.
        m_Instance = new PNsimulation;
    return m_Instance;
}


/** @brief AddTransitions
  *
  * @todo: document this function
  */
void PNsimulation::AddTransitions(PN_Transition* t)
{
    this->transRegister.push_back(t);
}

/** @brief ClearDeadTrans
  *
  * @todo: document this function
  */
void PNsimulation::ClearDeadTrans()
{
    list<PN_Transition*>::iterator it_var, it_end;
    it_var = this->transRegister.begin();
    it_end = this->transRegister.end();

    while(it_var != it_end)
    {
        if ((*it_var)->IsDead())
        {
            delete (*it_var);
            it_var = this->transRegister.erase(it_var);
        }
        else
        {
            it_var++;
        }
    }
}

typedef struct
{
    PN_Transition *target;
    PN_TransitionBinding *context;
} Bind;

/** @brief Run
  *
  * @todo: document this function
  */
void PNsimulation::Run()
{
    srand (time(NULL));

    bool noTransPossible = false;
    while(!noTransPossible)
    {
        //cout << "\n\tsearching for bindings (in " << this->transRegister.size() << " transitions)\n";
        list<PN_Transition*>::iterator it_var, it_end;
        vector<Bind> possibleTrans;

        it_var = this->transRegister.begin();
        it_end = this->transRegister.end();

        for(; it_var != it_end; it_var++)
        {
            if((*it_var) != NULL)
            {
                PN_TransitionBinding* binding = (*it_var)->GetBinding();
                if(binding != NULL)
                {
                    Bind b;
                    b.target = *it_var;
                    b.context = binding;
                    possibleTrans.push_back(b);
                    break;
                }
            }
        }

        int count = possibleTrans.size();
        if(count == 0)
        {
            noTransPossible = true;
            //cout << "no possible transitions\n";
        }
        else
        {
            int choose = 0 ;//rand() % count;
            Bind chosenExecutable;

            vector<Bind> ::iterator it_var, it_end;

            it_var = possibleTrans.begin();
            it_end = possibleTrans.end();
            int counter = 0;
            for(; it_var != it_end; it_var++, counter++)
            {
                if(counter == choose) // store chosen context
                {
                    chosenExecutable = possibleTrans[choose];

                    //possibleTrans.erase(it_var);
                }
                else // delete other contexts
                {
                    delete it_var->context;
                }
            }

//            cout << "chosen transtion " << choose << ": ";
//            chosenExecutable.context->Print();
//            cout << endl;

            try
            {
                chosenExecutable.target->ExecuteWithBinding(chosenExecutable.context);
            }
            catch (PN_JoinException *ex)
            {
                ex->Join();
                delete ex;
            }
            catch (PN_Exception *ex)
            {
                ex->Print();
                cout << endl;
                return;
            }
        }
    }

}



// /** @brief AddTransitions
//  *
//  * @todo: document this function
//  */
//void PNsimulation::AddTransitions(PetriNet* c)
//{
//    list<PN_Transition*>::iterator it_var, it_end;
//    it_var = c..begin();
//    it_end = classes.end();
//
//    for(; it_var != it_end; it_var++)
//    {
//        this.transRegister.push_back((*it_var));
//    }
//}


