#include "PerformanceAckermann.h"

PN_MetaClass *PerformanceAckermann::GetInstantiator()
{
	return new PN_MetaClass_PerformanceAckermann();
}

PerformanceAckermann::PerformanceAckermann()
{
	// ------------------places init----------------
	PN_Multiset *start_Multiset = new PN_Multiset();
	start_Multiset->AddItem(new PN_MultiItemSymbol(1, "e"));
	start = new PN_Place(start_Multiset, "start");

	end = new PN_Place("end");

	PN_Multiset *inv_Multiset = new PN_Multiset();
	inv_Multiset->AddItem(new PN_MultiItemInt(1, 0));
	inv = new PN_Place(inv_Multiset, "inv");

	// ----------------transitions init---------------
//-----------------transition t1 init-----------------
	PN_Transition *t1 = new PN_Transition("t1");
	this->RegisterTransition(t1);

	// ---------preconds-------
	list<PN_Condition *> t1_precond;

	PN_Multiset *t1_precondstart_Multiset = new PN_Multiset();
	t1_precondstart_Multiset->AddItem(new PN_MultiItemSymbol(1, "e"));
	t1_precond.push_back(new PN_Condition(start, t1_precondstart_Multiset));
	t1->SetPreconds(t1_precond);

	// ---------postconds-------
	list<PN_Condition *> t1_postcond;

	PN_Multiset *t1_postcondend_Multiset = new PN_Multiset();
	t1_postcondend_Multiset->AddItem(new PN_MultiItemSymbol(1, "e"));
	t1_postcond.push_back(new PN_Condition(end, t1_postcondend_Multiset));
	t1->SetPostconds(t1_postcond);

	// ---------action-------
	PN_Expression *t1_action_1;
	t1_action_1 = new PN_Expression(new PN_MessageBin(",", new PN_Operand_Token(new StringToken("***"))), new PN_Operand_Token(new StringToken("*** start")));
	t1_action_1->AddResultVar("___primary__");
	t1->AddAction(t1_action_1);

	PN_Expression *t1_action_2;
	t1_action_2 = new PN_Expression(NULL, new PN_Operand_Var("___primary__"));
	t1_action_2->AddResultVar("__key0__");
	t1->AddAction(t1_action_2);

	PN_Expression *t1_action_3;
	PN_MessageKeys *t1_action_3_key = new PN_MessageKeys("show:");
	t1_action_3_key->keys.push_back(new PN_Operand_Var("__key0__"));
	t1_action_3 = new PN_Expression(t1_action_3_key, new PN_Operand_Token(Transcript::GetInstantiator()));
	t1_action_3->AddResultVar("__primary__");
	t1->AddAction(t1_action_3);

	PN_Expression *t1_action_4;
	t1_action_4 = new PN_Expression(new PN_MessageUnary("millisecondClockValue"), new PN_Operand_Token(Time::GetInstantiator()));
	t1_action_4->AddResultVar("__primary__");
	t1->AddAction(t1_action_4);

	PN_Expression *t1_action_5;
	t1_action_5 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	t1_action_5->AddResultVar("t1");
	t1->AddAction(t1_action_5);

	PN_Expression *t1_action_6;
	t1_action_6 = new PN_Expression(NULL, new PN_Operand_Token(new IntToken(0)));
	t1_action_6->AddResultVar("n");
	t1->AddAction(t1_action_6);

	PN_Expression *t1_action_7;
	PN_MessageKeys *t1_action_7_key = new PN_MessageKeys("x:y:");
	t1_action_7_key->keys.push_back(new PN_Operand_Token(new IntToken(3)));
	t1_action_7_key->keys.push_back(new PN_Operand_Token(new IntToken(2)));
	t1_action_7 = new PN_Expression(t1_action_7_key, new PN_Operand_Token(new PNToken(this->GetSelf())));
	t1_action_7->AddResultVar("__primary__");
	t1->AddAction(t1_action_7);

	PN_Expression *t1_action_8;
	t1_action_8 = new PN_Expression(new PN_MessageUnary("millisecondClockValue"), new PN_Operand_Token(Time::GetInstantiator()));
	t1_action_8->AddResultVar("__primary__");
	t1->AddAction(t1_action_8);

	PN_Expression *t1_action_9;
	t1_action_9 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	t1_action_9->AddResultVar("t2");
	t1->AddAction(t1_action_9);

	PN_Expression *t1_action_10;
	t1_action_10 = new PN_Expression(new PN_MessageBin("-", new PN_Operand_Var("t1")), new PN_Operand_Var("t2"));
	t1_action_10->AddResultVar("_____primary__");
	t1->AddAction(t1_action_10);

	PN_Expression *t1_action_11;
	t1_action_11 = new PN_Expression(NULL, new PN_Operand_Var("_____primary__"));
	t1_action_11->AddResultVar("____primary__");
	t1->AddAction(t1_action_11);

	PN_Expression *t1_action_12;
	t1_action_12 = new PN_Expression(new PN_MessageUnary("printString"), new PN_Operand_Var("____primary__"));
	t1_action_12->AddResultVar("____primary__");
	t1->AddAction(t1_action_12);

	PN_Expression *t1_action_13;
	t1_action_13 = new PN_Expression(NULL, new PN_Operand_Var("____primary__"));
	t1_action_13->AddResultVar("___binArg__");
	t1->AddAction(t1_action_13);

	PN_Expression *t1_action_14;
	t1_action_14 = new PN_Expression(new PN_MessageBin(",", new PN_Operand_Var("___binArg__")), new PN_Operand_Token(new StringToken("*** end: ")));
	t1_action_14->AddResultVar("___primary__");
	t1->AddAction(t1_action_14);

	PN_Expression *t1_action_15;
	t1_action_15 = new PN_Expression(NULL, new PN_Operand_Var("___primary__"));
	t1_action_15->AddResultVar("__key0__");
	t1->AddAction(t1_action_15);

	PN_Expression *t1_action_16;
	PN_MessageKeys *t1_action_16_key = new PN_MessageKeys("show:");
	t1_action_16_key->keys.push_back(new PN_Operand_Var("__key0__"));
	t1_action_16 = new PN_Expression(t1_action_16_key, new PN_Operand_Token(Transcript::GetInstantiator()));
	t1_action_16->AddResultVar("__primary__");
	t1->AddAction(t1_action_16);

//-----------------transition t2 init-----------------
	PN_Transition *t2 = new PN_Transition("t2");
	this->RegisterTransition(t2);

	// ---------preconds-------
	list<PN_Condition *> t2_precond;

	PN_Multiset *t2_precondend_Multiset = new PN_Multiset();
	t2_precondend_Multiset->AddItem(new PN_MultiItemSymbol(1, "e"));
	t2_precond.push_back(new PN_Condition(end, t2_precondend_Multiset));
	PN_Multiset *t2_precondinv_Multiset = new PN_Multiset();
	t2_precondinv_Multiset->AddItem(new PN_MultiItemVariable(1, "n"));
	t2_precond.push_back(new PN_Condition(inv, t2_precondinv_Multiset));
	t2->SetPreconds(t2_precond);

	// ---------action-------
	PN_Expression *t2_action_1;
	t2_action_1 = new PN_Expression(new PN_MessageUnary("printString"), new PN_Operand_Var("n"));
	t2_action_1->AddResultVar("____primary__");
	t2->AddAction(t2_action_1);

	PN_Expression *t2_action_2;
	t2_action_2 = new PN_Expression(NULL, new PN_Operand_Var("____primary__"));
	t2_action_2->AddResultVar("___binArg__");
	t2->AddAction(t2_action_2);

	PN_Expression *t2_action_3;
	t2_action_3 = new PN_Expression(new PN_MessageBin(",", new PN_Operand_Var("___binArg__")), new PN_Operand_Token(new StringToken("*** pocet volani: ")));
	t2_action_3->AddResultVar("___primary__");
	t2->AddAction(t2_action_3);

	PN_Expression *t2_action_4;
	t2_action_4 = new PN_Expression(NULL, new PN_Operand_Var("___primary__"));
	t2_action_4->AddResultVar("__key0__");
	t2->AddAction(t2_action_4);

	PN_Expression *t2_action_5;
	PN_MessageKeys *t2_action_5_key = new PN_MessageKeys("show:");
	t2_action_5_key->keys.push_back(new PN_Operand_Var("__key0__"));
	t2_action_5 = new PN_Expression(t2_action_5_key, new PN_Operand_Token(Transcript::GetInstantiator()));
	t2_action_5->AddResultVar("__primary__");
	t2->AddAction(t2_action_5);

	//-------------------- sync ports -----------------------------
}

PerformanceAckermann::~PerformanceAckermann()
{
	delete start;
	delete end;
	delete inv;
}

PN_Place *PerformanceAckermann::GetPlace(string placeName)
{
	if (placeName == "start")
		return start;
	else if (placeName == "end")
		return end;
	else if (placeName == "inv")
		return inv;
	else 
		return NULL;
}

Token* PerformanceAckermann::SendMessage(string message, list<PN_Operand*>& args, list<PN_Binding>& binds)
{
	Token *result = NULL;
	if(message == "x:y:" )
	{
		PN_Operand *op;
		if (args.size() < 2)
		{
			throw new PN_NotEnoughArguments("PerformanceAckermann", "x:y:", 2, args.size());
		}
		op = args.front();
		args.pop_front();
		Token *arg1 = op->Resolve(binds);
		if (arg1 == NULL)
		{
			return NULL;
		}
		op = args.front();
		args.pop_front();
		Token *arg2 = op->Resolve(binds);
		if (arg2 == NULL)
		{
			return NULL;
		}
		throw new PN_MethodForkException(new PerformanceAckermann_x_y_(this, arg1, arg2));
	}
	return PN_Class::SendMessage(message, args, binds);
}


PerformanceAckermann_x_y_::PerformanceAckermann_x_y_(PN_Class *parentObj, Token *x_Operand, Token *y_Operand)
	:PN_Method_Net(parentObj){
	// ------------------places init----------------
	x = new PN_Place("x");

	y = new PN_Place("y");

	r = new PN_Place("r");

	_return = new PN_Place_Return(this);

	list<Token *> x_init;
	x_init.push_back(x_Operand);
	x->PushTokens(&x_init);

	list<Token *> y_init;
	y_init.push_back(y_Operand);
	y->PushTokens(&y_init);

	// ----------------transitions init---------------
//-----------------transition one init-----------------
	PN_Transition *one = new PN_Transition("one");
	this->RegisterTransition(one);

	// ---------preconds-------
	list<PN_Condition *> one_precond;

	PN_Multiset *one_precondx_Multiset = new PN_Multiset();
	one_precondx_Multiset->AddItem(new PN_MultiItemVariable(1, "x"));
	one_precond.push_back(new PN_Condition(x, one_precondx_Multiset));
	PN_Multiset *one_precondy_Multiset = new PN_Multiset();
	one_precondy_Multiset->AddItem(new PN_MultiItemVariable(1, "y"));
	one_precond.push_back(new PN_Condition(y, one_precondy_Multiset));
	one->SetPreconds(one_precond);

	// ---------postconds-------
	list<PN_Condition *> one_postcond;

	PN_Multiset *one_postcondr_Multiset = new PN_Multiset();
	one_postcondr_Multiset->AddItem(new PN_MultiItemVariable(1, "z"));
	one_postcond.push_back(new PN_Condition(r, one_postcondr_Multiset));
	one->SetPostconds(one_postcond);

	// --------- guard -------
	PN_Guard *one_guard_1 = new PN_Guard();
	PN_Expression *one_guard_1_expr_1;
	one_guard_1_expr_1 = new PN_Expression(new PN_MessageBin("=", new PN_Operand_Token(new IntToken(0))), new PN_Operand_Var("x"));
	one_guard_1->AddExpr(one_guard_1_expr_1);
	one->SetGuard(one_guard_1);

	// ---------action-------
	PN_Expression *one_action_1;
	one_action_1 = new PN_Expression(new PN_MessageBin("+", new PN_Operand_Token(new IntToken(1))), new PN_Operand_Var("y"));
	one_action_1->AddResultVar("__primary__");
	one->AddAction(one_action_1);

	PN_Expression *one_action_2;
	one_action_2 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	one_action_2->AddResultVar("z");
	one->AddAction(one_action_2);

//-----------------transition two init-----------------
	PN_Transition *two = new PN_Transition("two");
	this->RegisterTransition(two);

	// ---------preconds-------
	list<PN_Condition *> two_precond;

	PN_Multiset *two_precondx_Multiset = new PN_Multiset();
	two_precondx_Multiset->AddItem(new PN_MultiItemVariable(1, "x"));
	two_precond.push_back(new PN_Condition(x, two_precondx_Multiset));
	PN_Multiset *two_precondy_Multiset = new PN_Multiset();
	two_precondy_Multiset->AddItem(new PN_MultiItemVariable(1, "y"));
	two_precond.push_back(new PN_Condition(y, two_precondy_Multiset));
	two->SetPreconds(two_precond);

	// ---------postconds-------
	list<PN_Condition *> two_postcond;

	PN_Multiset *two_postcondr_Multiset = new PN_Multiset();
	two_postcondr_Multiset->AddItem(new PN_MultiItemVariable(1, "z"));
	two_postcond.push_back(new PN_Condition(r, two_postcondr_Multiset));
	two->SetPostconds(two_postcond);

	// --------- guard -------
	PN_Guard *two_guard_1 = new PN_Guard();
	PN_Expression *two_guard_1_expr_1;
	two_guard_1_expr_1 = new PN_Expression(new PN_MessageBin(">", new PN_Operand_Token(new IntToken(0))), new PN_Operand_Var("x"));
	two_guard_1->AddExpr(two_guard_1_expr_1);
	two->SetGuard(two_guard_1);

	PN_Guard *two_guard_2 = new PN_Guard();
	PN_Expression *two_guard_2_expr_1;
	two_guard_2_expr_1 = new PN_Expression(new PN_MessageBin("=", new PN_Operand_Token(new IntToken(0))), new PN_Operand_Var("y"));
	two_guard_2->AddExpr(two_guard_2_expr_1);
	two_guard_1->SetGuard(two_guard_2);

	// ---------action-------
	PN_Expression *two_action_1;
	two_action_1 = new PN_Expression(new PN_MessageBin("-", new PN_Operand_Token(new IntToken(1))), new PN_Operand_Var("x"));
	two_action_1->AddResultVar("__primary__");
	two->AddAction(two_action_1);

	PN_Expression *two_action_2;
	two_action_2 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	two_action_2->AddResultVar("x2");
	two->AddAction(two_action_2);

	PN_Expression *two_action_3;
	PN_MessageKeys *two_action_3_key = new PN_MessageKeys("x:y:");
	two_action_3_key->keys.push_back(new PN_Operand_Var("x2"));
	two_action_3_key->keys.push_back(new PN_Operand_Token(new IntToken(1)));
	two_action_3 = new PN_Expression(two_action_3_key, new PN_Operand_Token(new PNToken(this->GetSelf())));
	two_action_3->AddResultVar("__primary__");
	two->AddAction(two_action_3);

	PN_Expression *two_action_4;
	two_action_4 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	two_action_4->AddResultVar("z");
	two->AddAction(two_action_4);

//-----------------transition three init-----------------
	PN_Transition *three = new PN_Transition("three");
	this->RegisterTransition(three);

	// ---------preconds-------
	list<PN_Condition *> three_precond;

	PN_Multiset *three_precondx_Multiset = new PN_Multiset();
	three_precondx_Multiset->AddItem(new PN_MultiItemVariable(1, "x"));
	three_precond.push_back(new PN_Condition(x, three_precondx_Multiset));
	PN_Multiset *three_precondy_Multiset = new PN_Multiset();
	three_precondy_Multiset->AddItem(new PN_MultiItemVariable(1, "y"));
	three_precond.push_back(new PN_Condition(y, three_precondy_Multiset));
	three->SetPreconds(three_precond);

	// ---------postconds-------
	list<PN_Condition *> three_postcond;

	PN_Multiset *three_postcondr_Multiset = new PN_Multiset();
	three_postcondr_Multiset->AddItem(new PN_MultiItemVariable(1, "z"));
	three_postcond.push_back(new PN_Condition(r, three_postcondr_Multiset));
	three->SetPostconds(three_postcond);

	// --------- guard -------
	PN_Guard *three_guard_1 = new PN_Guard();
	PN_Expression *three_guard_1_expr_1;
	three_guard_1_expr_1 = new PN_Expression(new PN_MessageBin(">", new PN_Operand_Token(new IntToken(0))), new PN_Operand_Var("x"));
	three_guard_1->AddExpr(three_guard_1_expr_1);
	three->SetGuard(three_guard_1);

	PN_Guard *three_guard_2 = new PN_Guard();
	PN_Expression *three_guard_2_expr_1;
	three_guard_2_expr_1 = new PN_Expression(new PN_MessageBin(">", new PN_Operand_Token(new IntToken(0))), new PN_Operand_Var("y"));
	three_guard_2->AddExpr(three_guard_2_expr_1);
	three_guard_1->SetGuard(three_guard_2);

	// ---------action-------
	PN_Expression *three_action_1;
	three_action_1 = new PN_Expression(new PN_MessageBin("-", new PN_Operand_Token(new IntToken(1))), new PN_Operand_Var("x"));
	three_action_1->AddResultVar("__primary__");
	three->AddAction(three_action_1);

	PN_Expression *three_action_2;
	three_action_2 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	three_action_2->AddResultVar("x2");
	three->AddAction(three_action_2);

	PN_Expression *three_action_3;
	three_action_3 = new PN_Expression(new PN_MessageBin("-", new PN_Operand_Token(new IntToken(1))), new PN_Operand_Var("y"));
	three_action_3->AddResultVar("__primary__");
	three->AddAction(three_action_3);

	PN_Expression *three_action_4;
	three_action_4 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	three_action_4->AddResultVar("y2");
	three->AddAction(three_action_4);

	PN_Expression *three_action_5;
	PN_MessageKeys *three_action_5_key = new PN_MessageKeys("x:y:");
	three_action_5_key->keys.push_back(new PN_Operand_Var("x"));
	three_action_5_key->keys.push_back(new PN_Operand_Var("y2"));
	three_action_5 = new PN_Expression(three_action_5_key, new PN_Operand_Token(new PNToken(this->GetSelf())));
	three_action_5->AddResultVar("__primary__");
	three->AddAction(three_action_5);

	PN_Expression *three_action_6;
	three_action_6 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	three_action_6->AddResultVar("inner");
	three->AddAction(three_action_6);

	PN_Expression *three_action_7;
	PN_MessageKeys *three_action_7_key = new PN_MessageKeys("x:y:");
	three_action_7_key->keys.push_back(new PN_Operand_Var("x2"));
	three_action_7_key->keys.push_back(new PN_Operand_Var("inner"));
	three_action_7 = new PN_Expression(three_action_7_key, new PN_Operand_Token(new PNToken(this->GetSelf())));
	three_action_7->AddResultVar("__primary__");
	three->AddAction(three_action_7);

	PN_Expression *three_action_8;
	three_action_8 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	three_action_8->AddResultVar("z");
	three->AddAction(three_action_8);

//-----------------transition end init-----------------
	PN_Transition *end = new PN_Transition("end");
	this->RegisterTransition(end);

	// ---------preconds-------
	list<PN_Condition *> end_precond;

	PN_Multiset *end_precondinv_Multiset = new PN_Multiset();
	end_precondinv_Multiset->AddItem(new PN_MultiItemVariable(1, "n"));
	end_precond.push_back(new PN_Condition(this->GetPlace("inv"), end_precondinv_Multiset));
	PN_Multiset *end_precondr_Multiset = new PN_Multiset();
	end_precondr_Multiset->AddItem(new PN_MultiItemVariable(1, "x"));
	end_precond.push_back(new PN_Condition(r, end_precondr_Multiset));
	end->SetPreconds(end_precond);

	// ---------postconds-------
	list<PN_Condition *> end_postcond;

	PN_Multiset *end_postcondinv_Multiset = new PN_Multiset();
	end_postcondinv_Multiset->AddItem(new PN_MultiItemVariable(1, "nn"));
	end_postcond.push_back(new PN_Condition(this->GetPlace("inv"), end_postcondinv_Multiset));
	PN_Multiset *end_postcondreturn_Multiset = new PN_Multiset();
	end_postcondreturn_Multiset->AddItem(new PN_MultiItemVariable(1, "x"));
	end_postcond.push_back(new PN_Condition(_return, end_postcondreturn_Multiset));
	end->SetPostconds(end_postcond);

	// ---------action-------
	PN_Expression *end_action_1;
	end_action_1 = new PN_Expression(new PN_MessageBin("+", new PN_Operand_Token(new IntToken(1))), new PN_Operand_Var("n"));
	end_action_1->AddResultVar("__primary__");
	end->AddAction(end_action_1);

	PN_Expression *end_action_2;
	end_action_2 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	end_action_2->AddResultVar("nn");
	end->AddAction(end_action_2);

}

PerformanceAckermann_x_y_::~PerformanceAckermann_x_y_()
{
	delete x;
	delete y;
	delete r;
	delete _return;
}

