#include "TestBind.h"

PN_MetaClass *TestBind::GetInstantiator()
{
	return new PN_MetaClass_TestBind();
}

TestBind::TestBind()
{
	// ------------------places init----------------
	PN_Multiset *p1_Multiset = new PN_Multiset();
	p1_Multiset->AddItem(new PN_MultiItemInt(4, 5));
	p1_Multiset->AddItem(new PN_MultiItemInt(2, 4));
	p1_Multiset->AddItem(new PN_MultiItemInt(2, 2));
	p1 = new PN_Place(p1_Multiset, "p1");

	PN_Multiset *p2_Multiset = new PN_Multiset();
	p2_Multiset->AddItem(new PN_MultiItemInt(4, 6));
	p2 = new PN_Place(p2_Multiset, "p2");


	PN_Multiset *p3_Multiset = new PN_Multiset();
	p3_Multiset->AddItem(new PN_MultiItemInt(4, 4));
	p3_Multiset->AddItem(new PN_MultiItemInt(5, 6));
	p3 = new PN_Place(p3_Multiset, "p3");

	// ----------------transitions init---------------
//-----------------transition t1 init-----------------
	PN_Transition *t1 = new PN_Transition("t1");
	this->RegisterTransition(t1);

	// ---------preconds-------
	list<PN_Condition *> t1_precond;

	PN_Multiset *t1_precondp1_Multiset = new PN_Multiset();
	t1_precondp1_Multiset->AddItem(new PN_MultiItemVariable(2, "x"));
	t1_precondp1_Multiset->AddItem(new PN_MultiItemInt("x", 5));
	t1_precond.push_back(new PN_Condition(p1, t1_precondp1_Multiset));
	t1->SetPreconds(t1_precond);

	// ---------postconds-------
	list<PN_Condition *> t1_postcond;

	PN_Multiset *t1_postcondp2_Multiset = new PN_Multiset();
	t1_postcondp2_Multiset->AddItem(new PN_MultiItemVariable(2, "x"));
	t1_postcond.push_back(new PN_Condition(p2, t1_postcondp2_Multiset));
	t1->SetPostconds(t1_postcond);

	// ---------action-------
	PN_Expression *t1_action_1;
	t1_action_1 = new PN_Expression(new PN_MessageBin("+", new PN_Operand_Token(new IntToken(2))), new PN_Operand_Var("x"));
	t1_action_1->AddResultVar("__primary__");
	t1->AddAction(t1_action_1);

	PN_Expression *t1_action_2;
	t1_action_2 = new PN_Expression(NULL, new PN_Operand_Var("__primary__"));
	t1_action_2->AddResultVar("x");
	t1->AddAction(t1_action_2);

	PN_Expression *t1_action_3;
	t1_action_3 = new PN_Expression(new PN_MessageUnary("print"), new PN_Operand_Var("x"));
	t1_action_3->AddResultVar("__primary__");
	t1->AddAction(t1_action_3);

//-----------------transition t2 init-----------------
	PN_Transition *t2 = new PN_Transition("t2");
	this->RegisterTransition(t2);

	// ---------preconds-------
	list<PN_Condition *> t2_precond;

	PN_Multiset *t2_precondp2_Multiset = new PN_Multiset();
	t2_precondp2_Multiset->AddItem(new PN_MultiItemVariable("x", "x"));
	t2_precond.push_back(new PN_Condition(p2, t2_precondp2_Multiset));
	t2->SetPreconds(t2_precond);

	// ---------postconds-------
	list<PN_Condition *> t2_postcond;

	PN_Multiset *t2_postcondp3_Multiset = new PN_Multiset();
	t2_postcondp3_Multiset->AddItem(new PN_MultiItemInt(1, 4));
	t2_postcond.push_back(new PN_Condition(p3, t2_postcondp3_Multiset));
	t2->SetPostconds(t2_postcond);

	// ---------action-------
	PN_Expression *t2_action_1;
	t2_action_1 = new PN_Expression(new PN_MessageUnary("print"), new PN_Operand_Var("x"));
	t2_action_1->AddResultVar("__primary__");
	t2->AddAction(t2_action_1);

	//-------------------- sync ports -----------------------------
}

TestBind::~TestBind()
{
    p1->Clear();
	delete p1;
	p2->Clear();
	delete p2;
	p3->Clear();
	delete p3;
}

PN_Place *TestBind::GetPlace(string placeName)
{
	if (placeName == "p1")
		return p1;
	else if (placeName == "p2")
		return p2;
	else if (placeName == "p3")
		return p3;
	else
		return NULL;
}

