#include "PNparse_condition.h"

pnCondition::pnCondition(string _target, pnMultiset *set)
{
    target = _target;
    multiSet = set;
    usePlaceSearch = false;
    nextCondition = NULL;
}

void pnCondition::SetNextCond(pnCondition *next, bool disposeOld)
{
    if (disposeOld)
        delete nextCondition;
    nextCondition = next;
}

/** @brief CheckCorrectness
  *
  * @todo: document this function
  */
void pnCondition::MarkUnreachable(list<pnPlace*> places)
{
    list<pnPlace*>::iterator it_var, it_end;
    it_var = places.begin();
    it_end = places.end();

    bool found = false;
    for(; it_var != it_end; it_var++)
    {
        cout << "checking " << this->target << " vs. " << (*it_var)->name << endl;
        if(this->target == (*it_var)->name)
        {
            found = true;
            this->usePlaceSearch = false;
            break;
        }
    }
    if(!found)
    {
        this->usePlaceSearch = true;
    }

    if (this->nextCondition != NULL)
    {
        this->nextCondition->MarkUnreachable(places);
    }
}

void pnPlace::Print()
{
    cout << "\t\t\t" << name  << "(" ;
    if(this->initContent != NULL)
    {
        this->initContent->Print();
    }
    else
    {
        cout << "empty";
    }
    cout << ")" << endl;
}


/** @brief Print
  *
  * @todo: document this function
  */
void pnCondition::Print()
{
    cout << target << "(";
    this->multiSet->Print();
    cout << ")";
    if (this->nextCondition != NULL)
    {
        this->nextCondition->Print();
    }
}
