#ifndef PNPARSE_CONDITION_H_INCLUDED
#define PNPARSE_CONDITION_H_INCLUDED

#include <string>
#include "PNparse_multiset.h"

class pnPlace;

class pnCondition
{
    string target;
    bool usePlaceSearch;
    pnMultiset *multiSet;
    pnCondition *nextCondition;
public:
    pnCondition(string _target, pnMultiset *set);
    string GetTarget() {return target;}
    pnMultiset *GetMultiset() {return multiSet;}
    bool UsePlaceSearch() {return this->usePlaceSearch;}
    pnCondition *GetNextCondition() {return nextCondition;}
    void SetNextCond(pnCondition *next, bool disposeOld);
    void MarkUnreachable(list<pnPlace*> places);
    void Print();
};

class pnPlace
{
public:
    string name;
    pnMultiset *initContent;
    pnPlace(string id, pnMultiset* _initContent)
    {
        name = id;
        initContent = _initContent;
    }
    ~pnPlace()
    {
        delete initContent;
    }
    void Print();
    /*pnMultiset *findMultiset(pnMultiset *desiredMultiset, bool remove);
     */
};

#endif // PNPARSE_CONDITION_H_INCLUDED
