#ifndef PNPARSE_LITERALS_H_INCLUDED
#define PNPARSE_LITERALS_H_INCLUDED

#include <iostream>
#include <string>

using namespace std;

class Literal
{
public:
    virtual void Print()
    {
        cout << "undefined literal";
    }
    virtual void GenerateAddToMultiSet(ostringstream& text, string varName, string quantity, int level)=0;
    virtual string GenerateNewInstance()=0;
    virtual ~Literal(){}
};

class IntegerLiteral : public Literal
{
protected:
    int Value;
public:
    IntegerLiteral(int value);
    virtual void Print();
};

class StringLiteral : public Literal
{
protected:
    string Value;
public:
    StringLiteral(string value);
    virtual void Print();
};

class SymbolLiteral : public Literal
{
protected:
    string Value;
public:
    SymbolLiteral(string value);
    virtual void Print();
};

class CharLiteral : public Literal
{
protected:
    char Value;
public:
    CharLiteral(char value);
    virtual void Print();
};

class BoolLiteral : public Literal
{
protected:
    bool Value;
public:
    BoolLiteral(bool value);
    virtual void Print();
};

class NilLiteral : public Literal
{
public:
    virtual void Print();
};

#endif // PNPARSE_LITERALS_H_INCLUDED
