#include "PNparse_multiset.h"

pnMultiset::~pnMultiset()
{
    list<pnMultisetItem*>::iterator it_var, it_end;
    it_var = mItems.begin();
    it_end = mItems.end();

    for(; it_var != it_end; it_var++)
    {
        delete *it_var;
    }
}

void pnMultiset::AddItem(pnMultisetItem * item)
{
    mItems.push_back(item);
}

void pnMultiset::Print()
{
    list<pnMultisetItem*>::iterator it_var, it_end;
    it_var = mItems.begin();
    it_end = mItems.end();

    if(it_var != it_end)
    {
        (*it_var)->Print();
        it_var++;
    }

    for(; it_var != it_end; it_var++)
    {
        cout << ", ";
        (*it_var)->Print();
    }
}

void pnSetItem::Print()
{
    cout << "Unimplemented item";
}

pnMultisetItem::pnMultisetItem(pnSetItem *_item, int _quantity)
{
    item = _item;
    quantity = _quantity;
    quantityIsRef = false;
}

pnMultisetItem::pnMultisetItem(pnSetItem *_item, string varName)
{
    item = _item;
    refName = varName;
    quantityIsRef = true;
}

pnMultisetItem::~pnMultisetItem()
{
    delete item;
}

void pnMultisetItem::Print()
{
    if(quantityIsRef)
        cout << refName;
    else
        cout << quantity;
    cout << " x ";
    this->item->Print();
}

pnMultisetItemList::~pnMultisetItemList()
{
    list<pnSetItem*>::iterator it_var, it_end;
    it_var = mList.begin();
    it_end = mList.end();

    for(; it_var != it_end; it_var++)
    {
        delete *it_var;
    }
}

/** @brief Print
  *
  * @todo: document this function
  */
void pnMultisetItemList::Print()
{
    cout << "(";
    list<pnSetItem*>::iterator it_var, it_end;
    it_var = this->mList.begin();
    it_end = this->mList.end();

    if(it_var != it_end)
    {
        (*it_var)->Print();
        it_var++;
    }

    for(; it_var != it_end; it_var++)
    {
        cout << ", ";
        (*it_var)->Print();
    }
    cout << ")";
}
