%{
#include <stdlib.h>
void yyerror(char *);
#include "PNparse.h"
#include "y.tab.h"
%}

%%

  /* start class */
"main"	{
	  return MAIN;
	}
  /* class */
"class"	{
	  return CLASS;
	}
  /* inheritance */
"is_a"	{
	  return INHERITANCE;
	}
  /* object net */
"object"	{
	  return OBJECT;
	}
  /* METHOD net */
"method"	{
	  return METHOD;
	}
  /* constructor net */
"constructor"	{
	  return CONSTRUCTOR;
	}
  /* synchronous port */
"sync"	{
	  return SYNC;
	}
  /* place */
"place"	{
	  return PLACE;
	}
  /* init place */
"init"	{
	  return INIT;
	}
  /* transition */
"trans"	{
	  return TRANSITION;
	}
  /* condition */
"cond"	{
	  return COND;
	}
  /* precondition */
"precond"	{
	  return PRECOND;
	}
  /* postcondition */
"postcond"	{
    return POSTCOND;
  }
  /* guard */
"guard"	{
	  return GUARD;
	}
  /* action */
"action" {
      return ACTION;
	}

  /* string literal */
'(\\.|[^\'])*'    {
    yylval.strVal = yytext;
    return STRING_LITERAL;
    }

  /* letter */
[a-z] 	{
	yylval.sIndex = *yytext;
	return SMALLLETTER;
	}
  /* letter */
[A-Z] 	{
	yylval.sIndex = *yytext;
	return CAPLETTER;
	}
[a-zA-Z][a-zA-Z0-9]*: {
	  yylval.strVal = yytext;
	  //cout << "KEYSEL: " << yytext << " , send: " <<yylval.strVal<< endl;
	  return KEYSEL;
	}
  /* identifier */
[a-zA-Z][a-zA-Z0-9]* {
	  yylval.strVal = yytext;
	  /*cout << "id :" << yytext << endl;*/
	  return ID;
	}
[0-9]   {
	  yylval.iValue = *yytext - '0';
	  /*cout << "digit :" << yylval.iValue << endl;*/
	  return DIGIT;
	}
  /* integers */
[0-9]+ 	{
	yylval.iValue = atoi(yytext);
	return INTEGER;
	}

[-~!@%&*+|\\<>?/] {
		      yylval.sIndex = *yytext;
		      return BINSELCHAR;
		     }
  /* operators */
[{},()=`$#:'.] {
    //cout << " token chars: " << yytext << endl;
    return *yytext;
    }
  /* skip whitespace */
[ \t\n] ; /*{cout << "whitespace, ";}*/
  /* anything else is an error */
. {

    char msg[] = "invalid character: ";
    strcat(msg , yytext);
    yyerror(msg);
  }
%%
int yywrap(void) {
return 1;
}
